SystemOrganization addCategory: #'DiffEng-Tests'!
SystemOrganization addCategory: #'DiffEng-Matching'!
SystemOrganization addCategory: #'DiffEng-Trees'!
SystemOrganization addCategory: #'DiffEng-Annotation'!

!Collection methodsFor: '*diffeng-enumerating' stamp: 'cwp 6/20/2004 00:37'!
with: aCollection pairsDo: aBlock 
	^ self do: [:own | aCollection do: [:other | aBlock value: own value: other]]! !

TestResource subclass: #DESourceResource
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DESourceResource methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:52'!
setUp
	tree _ DENodeA name: #alpha label: #first.
	tree 
		addLeft: (DENodeB name: #beta label: #second);
		addRight: (DENodeA name: #gamma label: #third)
! !

!DESourceResource methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:55'!
tree
	^ tree! !

TestResource subclass: #DETargetResource
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DETargetResource methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:06'!
tree
	^ tree! !

!DETargetResource methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:06'!
setUp
	tree _ DESourceResource current tree copy.
	! !

Object subclass: #DEBlossom
	instanceVariableNames: 'edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Matching'!

!DEBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:53'!
isDestruction
	^ false! !

!DEBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:00'!
couldMatch: aBlossom
	^ true! !

DEBlossom subclass: #DENodeBlossom
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Matching'!

!DENodeBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:03'!
couldMatch: aBlossom
	^ aBlossom hasNode
		ifFalse: [true]
		ifTrue: [node couldMatch: aBlossom node]! !

!DENodeBlossom methodsFor: 'accessing' stamp: 'cwp 6/20/2004 00:08'!
node
	^ node! !

!DENodeBlossom class methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:46'!
for: aNode
	^ self new node: aNode! !

!DENodeBlossom methodsFor: 'accessing' stamp: 'cwp 6/19/2004 23:46'!
node: aNode
	node _ aNode! !

!DENodeBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:02'!
hasNode
	^ true! !

!DEBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:52'!
isCreation
	^ false! !

!DEBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:02'!
hasNode
	^ false! !

DEBlossom subclass: #DECreationBlossom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Matching'!

!DECreationBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:14'!
couldMatch: aBlossom
	^ aBlossom isDestruction not! !

!DECreationBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:52'!
isCreation
	^ true! !

DEBlossom subclass: #DEDestructionBlossom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Matching'!

!DEDestructionBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:53'!
isDestruction
	^ true! !

!DEDestructionBlossom methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:13'!
couldMatch: aBlossom
	^ aBlossom isCreation not! !

!DEBlossom methodsFor: 'accessing' stamp: 'cwp 6/21/2004 16:34'!
addEdge: anEdge
	edges ifNil: [edges _ OrderedCollection new].
	edges add: anEdge! !

!DEBlossom methodsFor: 'accessing' stamp: 'cwp 6/20/2004 12:52'!
edges
	^ edges ifNil: [#()]! !

Object subclass: #DEBipartiteGraph
	instanceVariableNames: 'edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Matching'!

!DEBipartiteGraph class methodsFor: 'instance creation' stamp: 'cwp 6/21/2004 13:00'!
source: sourceTree target: targetTree
	| source target edges |
	source _ sourceTree allNodes collect: [:ea | DENodeBlossom for: ea].
	target _ targetTree allNodes collect: [:ea | DENodeBlossom for: ea].
	source add: DECreationBlossom new.
	target add: DEDestructionBlossom new.
	edges _ OrderedCollection new.
	source with: target pairsDo: 
		[:s :t | (t couldMatch: s) ifTrue: [edges add: (DEEdge source: s target: t)]].
	^ self edges: edges! !

!DEBipartiteGraph class methodsFor: 'instance creation' stamp: 'cwp 6/21/2004 12:56'!
edges: edges
	^ self new edges: edges! !

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/21/2004 12:55'!
edges: aCollection
	edges _ aCollection! !

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/20/2004 13:38'!
edges
	^ edges! !

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/21/2004 16:38'!
parentOf: aBlossom
	| parent |
	(parent _ aBlossom node parent) ifNil: [^ nil].
	edges do: [:edge | edge nodeBlossomsDo: [:b | b node == parent ifTrue: [ ^ b]]].
	! !

Object subclass: #DENode
	instanceVariableNames: 'parent name label left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Trees'!

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:13'!
left
	^ left ifNil: [#()]! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
label
	^label! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:16'!
parent: anObject
	parent := anObject! !

!DENode methodsFor: 'testing' stamp: 'cwp 6/20/2004 00:10'!
couldMatch: aNode
	^ self class = aNode class! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
name
	^name! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:15'!
addLeft: aNode
	left ifNil: [left _ OrderedCollection new].
	left add: aNode.
	aNode parent: self.
	^ aNode! !

!DENode class methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:37'!
name: aSymbol label: aSymbol2 
	^ self new name: aSymbol; label: aSymbol2! !

DENode subclass: #DENodeA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Trees'!

!DENode methodsFor: 'enumerating' stamp: 'cwp 6/20/2004 00:16'!
allNodes
	^ self addAllNodesTo: Set new
! !

DENode subclass: #DENodeB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Trees'!

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:16'!
parent
	^parent! !

!DENode methodsFor: 'enumerating' stamp: 'cwp 6/20/2004 00:19'!
addAllNodesTo: aCollection
	aCollection add: self.
	self left do: [:ea | ea addAllNodesTo: aCollection].
	self right do: [:ea | ea addAllNodesTo: aCollection].
	^ aCollection! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:16'!
addRight: aNode
	right ifNil: [right _ SortedCollection new].
	right add: aNode.
	aNode parent: self.
	^ aNode! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
label: anObject
	label := anObject! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:13'!
right
	^ right ifNil: [#()]! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
name: anObject
	name := anObject! !

Object subclass: #DEAnnotator
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Annotation'!

!DEAnnotator methodsFor: 'annotating' stamp: 'cwp 6/21/2004 12:51'!
annotate
	self edges do: [:ea | self annotate: ea]! !

!DEAnnotator methodsFor: 'annotating' stamp: 'cwp 6/21/2004 16:40'!
attach: edge 
	| parent |
	parent _ graph parentOf: edge target.
	(parent notNil and: [parent edges first isCreation])
		ifTrue: [edge op: #noOp]
		ifFalse: [edge op: #attach]! !

!DEAnnotator methodsFor: 'accessing' stamp: 'cwp 6/21/2004 13:07'!
graph: anObject
	graph := anObject! !

!DEAnnotator methodsFor: 'annotating' stamp: 'cwp 6/21/2004 16:43'!
prune: edge 
	| parent |
	parent _ graph parentOf: edge source.
	(parent notNil and: [parent edges first isDestruction])
		ifTrue: [edge op: #noOp]
		ifFalse: [edge op: #prune]! !

!DEAnnotator methodsFor: 'accessing' stamp: 'cwp 6/21/2004 13:15'!
edges
	^ graph edges! !

!DEAnnotator methodsFor: 'accessing' stamp: 'cwp 6/21/2004 13:07'!
graph
	^graph! !

!DEAnnotator methodsFor: 'annotating' stamp: 'cwp 6/21/2004 12:42'!
annotate: edge 
	edge source isCreation ifTrue: [^ self attach: edge].
	edge target isDestruction ifTrue: [^ self prune: edge]! !

!DEAnnotator class methodsFor: 'as yet unclassified' stamp: 'cwp 6/21/2004 12:53'!
forGraph: aBipartiteGraph
	^ self new graph: aBipartiteGraph! !

!DEAnnotator class methodsFor: 'as yet unclassified' stamp: 'cwp 6/21/2004 12:53'!
annotate: aGraph 
	^ (self forGraph: aGraph) annotate! !

Object subclass: #DEEdge
	instanceVariableNames: 'source target annotation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Matching'!

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/21/2004 16:44'!
isDestruction
	^ target isDestruction! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/21/2004 16:33'!
isCreation
	^ source isCreation! !

!DEEdge methodsFor: 'enumerating' stamp: 'cwp 6/21/2004 16:33'!
nodeBlossomsDo: aBlock
	source isCreation ifFalse: [aBlock value: source].
	target isDestruction ifFalse: [aBlock value: target]! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/21/2004 12:04'!
update: aSymbol
	self annotation addUpdateOp: aSymbol! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/21/2004 12:03'!
annotation
	^ annotation ifNil: [annotation _ DEAnnotation noOp]! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/21/2004 12:04'!
op: aSymbol
	self annotation structuralOp: aSymbol! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:26'!
target: anObject
	target := anObject.
	target addEdge: self! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/20/2004 00:03'!
source
	^source! !

!DEEdge class methodsFor: 'instance creation' stamp: 'cwp 6/20/2004 00:39'!
source: aBlossom1 target: aBlossom2 
	^ self new source: aBlossom1; target: aBlossom2! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/20/2004 00:03'!
target
	^target! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:26'!
source: anObject
	source := anObject.
	source addEdge: self! !

Object subclass: #DEAnnotation
	instanceVariableNames: 'structuralOp updateOps dependency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Annotation'!

!DEAnnotation methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:43'!
dependency: anObject
	dependency := anObject! !

!DEAnnotation class methodsFor: 'as yet unclassified' stamp: 'cwp 6/21/2004 12:00'!
op: aStructuralOperation
	^ self new structuralOp: aStructuralOperation! !

!DEAnnotation class methodsFor: 'as yet unclassified' stamp: 'cwp 6/21/2004 12:40'!
noOp
	^ self op: #noOp! !

!DEAnnotation methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:49'!
updateOps
	^ updateOps ifNil: [Set new]! !

!DEAnnotation methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:44'!
addUpdateOp: aSelector
	updateOps ifNil: [updateOps _ Set new].
	updateOps add: aSelector! !

!DEAnnotation methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:42'!
structuralOp: anObject
	structuralOp := anObject! !

!DEAnnotation methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:43'!
dependency
	^dependency! !

!DEAnnotation methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:42'!
structuralOp
	^structuralOp! !

TestCase subclass: #DEBipartiteGraphTest
	instanceVariableNames: 'graph edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:16'!
testDestructionBlossom
	self assert: (edges select: [:ea | ea target isDestruction]) size = 3! !

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:16'!
testCreationBlossom
	self assert: (edges select: [:ea | ea source isCreation]) size = 3! !

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:17'!
testEdgeValidity
	self assert: edges size = 11.
	edges do: [:ea | self assert: (ea source couldMatch: ea target)]! !

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:16'!
setUp
	graph := DEBipartiteGraph source: DESourceResource current tree
				target: DETargetResource current tree.
	edges := graph edges! !

TestCase subclass: #DEAnnotationTest
	instanceVariableNames: 'graph edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/21/2004 12:19'!
node
	^DENodeA name: #foo label: #bar! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/21/2004 12:19'!
nodeBlossom
	^DENodeBlossom for: self node! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/21/2004 13:14'!
buildGraph
	graph _ DEBipartiteGraph edges: edges.
	^ graph! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/21/2004 12:30'!
assertFirstEdgeIsPruned
	self assert: edges first annotation structuralOp = #prune.
	self assert: edges first annotation updateOps isEmpty.
	self assert: edges first annotation dependency = nil! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/21/2004 13:16'!
testPruneTwig
	| parent |
	parent := self createTwig.
	edges add: (self destructionOf: parent).
	edges add: (self destructionOf: parent left first).
	DEAnnotator annotate: self buildGraph.
	self assertEdgeAt: 1 is: #prune.
	self assertEdgeAt: 2 is: #noOp.
	! !

!DEAnnotationTest methodsFor: 'running' stamp: 'cwp 6/21/2004 11:47'!
setUp
	edges _ OrderedCollection new! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/21/2004 13:16'!
testPruneLeaf
	edges add: (self destructionOf: self node).
	DEAnnotator annotate: self buildGraph.
	self assertEdgeAt: 1 is: #prune! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/21/2004 13:16'!
testAttachTwig
	| parent |
	parent := self createTwig.
	edges add: (self creationOf: parent).
	edges add: (self creationOf: parent left first).
	DEAnnotator annotate: self buildGraph.
	self assertEdgeAt: 1 is: #attach.
	self assertEdgeAt: 2 is: #noOp.! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/21/2004 12:23'!
createTwig
	^ self node addLeft: self node; yourself
	! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/21/2004 12:28'!
destructionOf: aNode 
	^DEEdge source: (DENodeBlossom for: aNode) target: DEDestructionBlossom new ! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/21/2004 12:32'!
assertEdgeAt: index is: operation 
	| annotation |
	annotation := (edges at: index) annotation.
	self assert: annotation structuralOp = operation.
	self assert: annotation updateOps isEmpty.
	self assert: annotation dependency = nil! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/21/2004 12:19'!
creationOf: aNode
	^ DEEdge source: (DECreationBlossom new) target: (DENodeBlossom for: aNode)! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/21/2004 13:14'!
testAttachLeaf
	edges add: (self creationOf: self node).
	DEAnnotator annotate: self buildGraph.
	self assertEdgeAt: 1 is: #attach! !
